/****************************************************************************
**
** Copyright (C) 2004-2006 Trolltech ASA. All rights reserved.
**
** This file is part of the example classes of the Qt Toolkit.
**
** This file may be used under the terms of the GNU General Public
** License version 2.0 as published by the Free Software Foundation
** and appearing in the file LICENSE.GPL included in the packaging of
** this file.  Please review the following information to ensure GNU
** General Public Licensing requirements will be met:
** http://www.trolltech.com/products/qt/opensource.html
**
** If you are unsure which license is appropriate for your use, please
** review the following information:
** http://www.trolltech.com/products/qt/licensing.html or contact the
** sales department at sales@trolltech.com.
**
** This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
** WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
**
****************************************************************************/

#include <QtGui>
#include <cumacros.h>
#include "mysqlmodel.h"
#include <QtDebug>

MySqlModel::MySqlModel(QObject *parent)  : QSqlQueryModel(parent)
{
}

QVariant MySqlModel::data(const QModelIndex &index, int role) const
{
    QVariant value = QSqlQueryModel::data(index, role);
    if (value.isValid() && role == Qt::DisplayRole) {
        if (index.column() == 0)  {
            QDateTime data  = value.toDateTime();
            return data.toString("yyyy-MM-dd hh:mm:ss.zzz");
        }
        else if(index.column() == 1) {
            // remove long fully qualified name
            QRegularExpression re("(?:tango://)*(.*):\\d+/(.*)");
            QString s = value.toString();
            QRegularExpressionMatch ma = re.match(s);
            if(ma.capturedTexts().size() > 2) {
                QString s = ma.capturedTexts().at(1);
                s.contains(".") ? s = "[" + s.section('.', 0, 0) + "] " + ma.capturedTexts()[2] : s = s + ma.capturedTexts()[2];
                return s;
            }
        }
    }
    return value;
}
